package de.intevation.flys.client.server;

import org.w3c.dom.Document;

import org.apache.log4j.Logger;

import de.intevation.artifacts.common.utils.ClientProtocolUtils;

import de.intevation.flys.client.shared.exceptions.ServerException;
import de.intevation.flys.client.shared.model.Collection;
import de.intevation.flys.client.client.services.SetCollectionTTLService;


/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class SetCollectionTTLServiceImpl
extends      DoCollectionAction
implements   SetCollectionTTLService
{
    private static final Logger logger =
        Logger.getLogger(SetCollectionTTLServiceImpl.class);


    public static final String XPATH_RESULT      = "/art:result/text()";
    public static final String OPERATION_FAILURE = "FAILED";

    public void setTTL(Collection c)
    throws ServerException
    {
        logger.info("Set ttl of collection: " + c.identifier());

        String url = getServletContext().getInitParameter("server-url");

        long   ttl   = c.getTTL();
        String value = null;

        if (ttl == 0) {
            value = "INF";
        }
        else if (ttl < 0) {
            value = "DEFAULT";
        }
        else {
            value = String.valueOf(ttl);
        }

        Document set = ClientProtocolUtils.newSetCollectionTTLDocument(value);

        doAction(c, set, url);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
